/*=================================================================================
	ledshift_eeprom.c
-----------------------------------------------------------------------------------
	ݒۑ@\tLEDVtg_svO

	{[h̓쒆ɃXCb`SW2Ɠݒ胂[hɈڍs܂BXɃXCb`
	SW2ƂɂLED̃Vtg_ݒ肵AXCb`SW3Č肵܂B
	ăXCb`SW2ɂAVtg_xݒ肵́ASW3܂SW4Ƃ
	LEDVtg_̐ݒύXI܂B̂ƂASW4ƃf[^EEPROMɐݒe
	ۑASW3ƃf[^EEPROMɐݒeۑ܂B
=================================================================================*/
#include <p30f5011.h>	//TRISB̓@\WX^gp邽߂ɌĂяo
#include "lib_eeprom.h"	//f[^EEPROMɃANZX֐gp邽߂ɌĂяo
#include "lcd.h"		//wait֐сALCD֘Å֐gp邽߂ɌĂяo

//Configuration bits (dsPIC̊{ݒ)----------------------------------------------
_FOSC(CSW_FSCM_OFF & FRC_PLL8);		//RCiNbNj8{, NbNj^[OFF
_FWDT(WDT_OFF);						//EHb`hbO^C}[OFF
_FBORPOR(PBOR_OFF & MCLR_EN);		//uEAEgZbgOFF, }X^[NAL
_FGS(CODE_PROT_OFF);				//R[hیOFF
//---------------------------------------------------------------------------------
#define NULL 0x00					//NULL0x00Ƃ

unsigned int dir;					//LEDVtg_̕
unsigned int val;					//LEDVtg_̑x
char lcddata[12];					//LCDpf[^z
int t;								//҂

int main(void)
{
	unsigned int shiftdata=0x0001;	//LEDɏo͂Vtgf[^

	TRISB = 0xffc0;					//RB5-RB0Fo
	TRISD = 0xff00;					//RD11-RD8F,RD7-RD0Fo

	SR = ((SR & 0xff1f) | 0x0020);	//MPU荞ݗDx1ɐݒ
	INTCON1 = 0x8000;				//d荞݋֎~
	INTCON2 = 0x0000;				//IVTgpAINT1̊荞݂͗オGbWƂ

	IPC4 = ((IPC4 & 0xfff8) | 0x0005);	//INT1荞ݗDx5ɐݒ
	IFS1 = (IFS1 & 0xfffe);				//INT1荞݃tONA
	IEC1 = ((IEC1 & 0xfffe) | 0x0001);	//INT1荞݋,RD8sINT1ɂȂ

	eeprom_rd(0xFC40,&dir);		//EEPROMP[h(dir̒l)ǂݏo
	eeprom_rd(0xFC42,&val);		//EEPROMP[h(val̒l)ǂݏo

	switch(val){					//_LEDVtgx̕ύX
		case 0:		t=200;			//200ms/dot
					break;
		case 1:		t=500;			//500ms/dot
					break;
		case 2:		t=1000;			//1000ms/dot
					break;
		default:	t=200;			//200ms/dot
					val=0;
					break;
	}

	InitLCD();						//LCD

	if(dir==0){
		LocateLCD(0,0);				//LCD1sڂ̐擪ɃJ[\߂
		PrintLCD("LEFT \n");		//LCD1sڂɁuLEFTv\
	}
	else{
		if(dir==1){
			LocateLCD(0,0);			//LCD1sڂ̐擪ɃJ[\߂
			PrintLCD("RIGHT\n");	//LCD1sڂɁuRIGHTv\
		}
		else{
			LocateLCD(0,0);			//LCD1sڂ̐擪ɃJ[\߂
			PrintLCD("LEFT \n");	//LCD1sڂɁuLEFTv\
			dir=0;
		}
	}

	lcddata[0] = '0' + t % 10000 / 1000;	//10i4
	lcddata[1] = '0' + t % 1000 / 100;		//10i3
	lcddata[2] = '0' + t % 100 / 10;		//10i2
	lcddata[3] = '0' + t % 10;				//10i1
	lcddata[4] = ' ';
	lcddata[5] = 'm';
	lcddata[6] = 's';
	lcddata[7] = '/';
	lcddata[8] = 'b';
	lcddata[9] = 'i';
	lcddata[10] = 't';
	lcddata[11] = NULL;				//̏I
	PrintLCD(lcddata);				//LCDlcddata̓e\

	while(1){
		if(dir==0){
			shiftdata = (shiftdata << 1)|(shiftdata >> 7);	//1rbgVtg
		}
		else
		{
			if(dir==1){
				shiftdata = (shiftdata >> 1)|(shiftdata << 7);	//E1rbgVtg
			}
		}

		PORTD = shiftdata;	//shiftdata̓e|[gDɏo͂
		wait(t);			//t ms҂
	}

	return 0;
}

/* XCb`iSW2jƂɊ荞ݏ */
void __attribute__((interrupt)) _INT1Interrupt(void)
{
	int buff[5]={0,0,0,0,0};	//buffFINT1̓͒lz

	//ȈՃ`^O΍ for SW2
	while(1){
		buff[4] = buff[3];	//INT1̓͒lVtg
		buff[3] = buff[2];	//buff[4]=>ŏ̓͒l,buff[0]=>Ō̓͒l
		buff[2] = buff[1];
		buff[1] = buff[0];
		buff[0] = (PORTD & 0x0100);	//RD8(INT1)ȊO}XN
		//5'H'xoA[v𔲂B
		if(buff[0]&buff[1]&buff[2]&buff[3]&buff[4]) break;
		wait(1);	//1ms҂
	}

	while(1){
		if(!(PORTD & 0x0100)){	//XCb`iSW2jƂ

			//ȈՃ`^O΍ for SW2
			buff[4] = buff[3] = buff[2] = buff[1] = buff[0] = 0;	//buffNA
			while(1){
				buff[4] = buff[3];
				buff[3] = buff[2];
				buff[2] = buff[1];
				buff[1] = buff[0];
				buff[0] = (PORTD & 0x0100);
				if(buff[0]&buff[1]&buff[2]&buff[3]&buff[4]) break;
				wait(1);
			}

			dir ^= 1;						//LEDVtg_𔽓]

			if(dir==0){
				LocateLCD(0,0);				//LCD1sڂ̐擪ɃJ[\߂
				PrintLCD("LEFT ");			//LCD1sڂɁuLEFTv\
			}
			else{
				LocateLCD(0,0);				//LCD1sڂ̐擪ɃJ[\߂
				PrintLCD("RIGHT");			//LCD1sڂɁuRIGHTv\
			}
		}

		if(!(PORTD & 0x0200))break;			//XCb`iSW3jƃ[v甲
	}

	//ȈՃ`^O΍ for SW3
	buff[4] = buff[3] = buff[2] = buff[1] = buff[0] = 0;	//buffNA
	while(1){
		buff[4] = buff[3];
		buff[3] = buff[2];
		buff[2] = buff[1];
		buff[1] = buff[0];
		buff[0] = (PORTD & 0x0200);	//RD9ȊO}XN
		if(buff[0]&buff[1]&buff[2]&buff[3]&buff[4]) break;
		wait(1);
	}

	while(1){
		if(!(PORTD & 0x0100)){	//XCb`iSW2jƂ

			//ȈՃ`^O΍ for SW2
			buff[4] = buff[3] = buff[2] = buff[1] = buff[0] = 0;	//buffNA
			while(1){
				buff[4] = buff[3];
				buff[3] = buff[2];
				buff[2] = buff[1];
				buff[1] = buff[0];
				buff[0] = (PORTD & 0x0100);
				if(buff[0]&buff[1]&buff[2]&buff[3]&buff[4]) break;
				wait(1);
			}

			//LEDVtg_x̕ύX
			val++;
			if(val==3)val=0;
			switch(val){
				case 0:		t=200;		//200ms/dot
							break;
				case 1:		t=500;		//500ms/dot
							break;
				case 2:		t=1000;		//1000ms/dot
							break;
				default:	t=200;		//200ms/dot
							break;
			}

			//LCD\XV
			lcddata[0] = '0' + t % 10000 / 1000;	//10i4
			lcddata[1] = '0' + t % 1000 / 100;		//10i3
			lcddata[2] = '0' + t % 100 / 10;		//10i2
			lcddata[3] = '0' + t % 10;				//10i1
			LocateLCD(0,1);					//LCD2sڂ̐擪ɃJ[\߂
			PrintLCD(lcddata);				//LCDlcddata̓e\
		}

		if(!(PORTD & 0x0200))break;		//XCb`iSW3jƃ[v甲
		if(!(PORTD & 0x0400)){			//XCb`iSW4jƃZ[uă[v甲
			eeprom_erase(0xFC40);		//1[h
			eeprom_wr(0xFC40,dir);		//1[h(dir̒l)
			eeprom_erase(0xFC42);		//1[h
			eeprom_wr(0xFC42,val);		//1[h(val̒l)
			break;
		}
	}

	IFS1 = (IFS1 & 0xfffe);			//INT1荞݃tONA
}
